/*
FRODO: a FRamework for Open/Distributed Optimization
Copyright (C) 2008, 2009, 2010, 2011  Thomas Leaute, Brammert Ottens & Radoslaw Szymanek

FRODO is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FRODO is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.


How to contact the authors: 
<http://lia.epfl.ch/>

EPFL / IC / IIF / LIA
Batiment IN 
Station 14 
CH - 1015 Lausanne 
Switzerland
*/

package ch.epfl.lia.frodo.algorithms.varOrdering.dfs;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import ch.epfl.lia.frodo.communication.MessageWith2Payloads;

/** A token indicating that the destination variable is a child of the sender variable */
public class CHILDmsg extends MessageWith2Payloads <String, String> implements Externalizable {
	
	/** Used for serialization */
	private static final long serialVersionUID = -6158434988997871871L;
	
	/** Empty constructor */
	public CHILDmsg () {
		super.type = DFSgeneration.CHILD_MSG_TYPE;
	}

	/** Constructor 
	 * @param sender 	sender variable
	 * @param dest 		recipient variable
	 */
	public CHILDmsg (String sender, String dest) {
		super (DFSgeneration.CHILD_MSG_TYPE, sender, dest);
	}
	
	/** @see java.io.Externalizable#writeExternal(java.io.ObjectOutput) */
	public void writeExternal(ObjectOutput out) throws IOException {
		out.writeObject(this.getSender());
		out.writeObject(this.getDest());
	}

	/** @see java.io.Externalizable#readExternal(java.io.ObjectInput) */
	public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
		super.setPayload1((String) in.readObject());
		super.setPayload2((String) in.readObject());
	}

	/** @return the sender variable */
	public String getSender () {
		return getPayload1();
	}
	
	/** @return the recipient variable */
	public String getDest () {
		return getPayload2();
	}
}